<script lang="ts" setup>
// import Graph from "../components/Graph.vue";
import {
  usersGetUser,
  type Unit,
  unitsGetUnits,
  groupsGetGroups,
  usersGetGroups,
} from "@/scripts/api-helper";
import {
  unitFromCode,
  findUnitPath,
  unitToUnitsTree,
} from "@/scripts/algorithms";
import { computed, reactive } from "vue";
import { useRoute } from "vue-router";
import Breadcrumb from "@/components/Breadcrumb.vue";
import type { UnitsTree, BreadcrumbRoute } from "@/scripts/client-types";
import DataTable from "@/components/DataTable.vue";
import SubunitsView from "@/components/units/SubunitsView.vue";
import { useQuery } from "vue-query";
import UnitCard from "@/components/UnitCard.vue";
import GroupCard from "@/components/GroupCard.vue";
import router from "@/router";
import breakpoints from "@/scripts/breakpoints";

const route = useRoute();
const user_uid = route.params.uid as string;

const { isLoading, isError, data } = useQuery(
  `get-user-${user_uid}`,
  async () => {
    const res = await usersGetUser({ uid: user_uid });
    if (!res.ok) {
      throw new Error("Failed to get user");
    }
    return res.data;
  }
);

const {
  isLoading: groupsIsLoading,
  isError: groupsIsError,
  data: groupsData,
} = useQuery(`groups-of-user-${user_uid}`, async () => {
  const res = await usersGetGroups({ user: user_uid });
  if (!res.ok) {
    throw new Error("Failed to get users's groups");
  }
  return res.data;
});

function avatarClicked() {
  console.log("Avatar clicked");
}
</script>

<template>
  <div>
    <div v-if="isLoading" class="flex flex-row justify-center">
      <v-progress-circular
        :size="74"
        :width="11"
        indeterminate
      ></v-progress-circular>
    </div>
    <div v-if="isError">
      <h1>Impossible d'afficher l'utilisateur</h1>
    </div>
    <div v-else class="flex flex-col w-full">
      <div class="flex">
        <div
          class="flex-grow overflow-hidden bg-theme-background-accent shadow rounded-lg md:mr-2 mb-2 md:mb-0"
        >
          <div class="m-4 flex flex-col md:flex-row justify-between">
            <h3 class="text-zinc-900 text-xl">Compte AGEPoly</h3>
            <div class="flex flex-col justify-center">
              <p class="text-2xs md:text-xs">UUID: {{ data?.uid }}</p>
            </div>
          </div>

          <div class="flex m-4">
            <div class="m-2 flex flex-col justify-center">
              <v-tooltip location="bottom" text="Cliquer pour changer">
                <template v-slot:activator="{ props }">
                  <v-avatar
                    :size="breakpoints.lg ? 120 : 60"
                    class="cursor-pointer hover:opacity-80"
                    color="surface-variant"
                    v-bind="props && breakpoints.md"
                    @click="avatarClicked"
                  >
                    <span class="text-2xl lg:text-6xl">?</span>
                  </v-avatar>
                </template>
              </v-tooltip>
            </div>

            <dl class="flex-grow flex flex-col justify-center">
              <div class="px-4 py-2 lg:grid lg:grid-cols-3 lg:gap-4 lg:px-6">
                <dt class="text-sm font-medium text-gray-500">
                  <label
                    class="block mb-2 text-sm font-medium text-gray-600 dark:text-gray-200"
                    for="login-id"
                  >
                    Nom d'usage :
                  </label>
                </dt>
                <dd class="col-span-2">
                  <input
                    id="login-id"
                    :value="data?.display_name"
                    class="block w-full px-4 py-2 bg-zinc-100 rounded"
                    disabled
                    type="text"
                  />
                </dd>
              </div>
              <div class="px-4 py-2 lg:grid lg:grid-cols-3 lg:gap-4 lg:px-6">
                <dt class="text-sm font-medium text-gray-500">
                  <label
                    class="block mb-2 text-sm font-medium text-gray-600 dark:text-gray-200"
                    for="login-id"
                  >
                    Email Whiskey :
                  </label>
                </dt>
                <dd class="col-span-2">
                  <input
                    id="login-id"
                    :value="data?.email"
                    class="block w-full px-4 py-2 bg-zinc-100 rounded"
                    disabled
                    type="text"
                  />
                </dd>
              </div>
            </dl>
          </div>
        </div>

        <div class="">
          <div
            class="flex flex-col bg-theme-background-accent shadow rounded-lg mb-2"
          >
            <h3 class="m-4 text-zinc-900 text-xl">Données EPFL</h3>

            <dl>
              <div class="px-4 py-2 sm:grid sm:grid-cols-3 sm:gap-4 sm:px-6">
                <dt class="text-sm font-medium text-gray-500">SCIPER</dt>
                <dd class="mt-1 text-sm sm:col-span-2 sm:mt-0">
                  {{ data?.sciper ?? "n/a" }}
                </dd>
              </div>
              <div class="px-4 py-2 sm:grid sm:grid-cols-3 sm:gap-4 sm:px-6">
                <dt class="text-sm font-medium text-gray-500">Nom</dt>
                <dd class="mt-1 text-sm sm:col-span-2 sm:mt-0">Fake</dd>
              </div>
              <div class="px-4 py-2 sm:grid sm:grid-cols-3 sm:gap-4 sm:px-6">
                <dt class="text-sm font-medium text-gray-500">Prénom</dt>
                <dd class="mt-1 text-sm sm:col-span-2 sm:mt-0">Fake Fake</dd>
              </div>
              <div class="px-4 py-2 sm:grid sm:grid-cols-3 sm:gap-4 sm:px-6">
                <dt class="text-sm font-medium text-gray-500">Email EPFL:</dt>
                <dd class="mt-1 text-sm sm:col-span-2 sm:mt-0">
                  fake.fake@epfl.ch
                </dd>
              </div>
            </dl>
          </div>

          <div class="space-y-2">
            <a
            v-if="data?.sciper"
            :href="`https://people.epfl.ch/${data.sciper}`"
            target="_blank"
          >
            <v-btn block>Profil People</v-btn>
          </a>
          <v-btn block variant="tonal" @click="router.push(`/admin/user-edition/${user_uid}`)">Éditer l'utilisateur</v-btn>
          </div>
        </div>
      </div>
      <div class="">
        <h3 class="text-2xl py-3">
          Groupes effectifs de {{ data?.display_name }}
        </h3>
        <div v-if="groupsIsLoading" class="flex flex-row justify-center">
          <v-progress-circular
            :size="50"
            :width="8"
            indeterminate
          ></v-progress-circular>
        </div>
        <div v-else-if="groupsIsError">
          <p>Unable to load groups</p>
        </div>
        <div v-else>
          <div
            class="grid grid-cols-1 md:grid-cols-1 lg:grid-cols-2 2xl:grid-cols-3 gap-4"
          >
            <GroupCard
              v-for="g of groupsData"
              v-bind:key="g.name"
              :abv="g.abv"
              :name="g.name"
              :unit="g.unit_code"
              @click="router.push(`/groups/${g.uid}`)"
            />
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
